> For the complete documentation index, see [llms.txt](https://docs.feathery.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.feathery.io/develop/react/api-guide/form/contextref.md).

# contextRef

### Overview

`contextRef` is a [\<Feathery.Form>](/develop/react/api-guide/form.md) prop that will set the `current` property of a ref to an instance containing form state and functions useful for interacting with the form.

### Usage <a href="#usage" id="usage"></a>

You can set the current form step, update a field value, get the current step name, and more.

```typescript
import { useRef } from 'react';
import { init, Form, FormContext } from '@feathery/react';

function App() {
  // Initialize Feathery
  init('SDKKey', 'support@feathery.io');
  const context = useRef<FormContext>(null);

  // After the Form is rendered, and the ref is set, you can
  // access any of the properties listed below
  setTimeout(() => context.current.setStep('New Step'), 1000);

  // Show the `aBcDeF` Feathery form
  return <Form
    formId='aBcDeF'
    // Fetch the Feathery form context
    contextRef={context}
  />
}
```

### [Context API](/develop/context-api.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.feathery.io/develop/react/api-guide/form/contextref.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
